searchNodes=[{"doc":"Documentation for Kalevala.","ref":"Kalevala.html","title":"Kalevala","type":"module"},{"doc":"Get the loaded version of Kalevala","ref":"Kalevala.html#version/0","title":"Kalevala.version/0","type":"function"},{"doc":"A struct for holding a character&#39;s brain and state","ref":"Kalevala.Brain.html","title":"Kalevala.Brain","type":"module"},{"doc":"Get a value from the brain&#39;s state","ref":"Kalevala.Brain.html#get/3","title":"Kalevala.Brain.get/3","type":"function"},{"doc":"Put a value in the brain&#39;s state","ref":"Kalevala.Brain.html#put/4","title":"Kalevala.Brain.put/4","type":"function"},{"doc":"Process a new event based on the character&#39;s brain data","ref":"Kalevala.Brain.html#run/3","title":"Kalevala.Brain.run/3","type":"function"},{"doc":"Node to trigger an action","ref":"Kalevala.Brain.Action.html","title":"Kalevala.Brain.Action","type":"module"},{"doc":"Check if a condition is valid Returns error if it does not match","ref":"Kalevala.Brain.Condition.html","title":"Kalevala.Brain.Condition","type":"behaviour"},{"doc":"","ref":"Kalevala.Brain.Condition.html#c:match?/3","title":"Kalevala.Brain.Condition.match?/3","type":"callback"},{"doc":"Processes each node one at a time and stops processing when the first one fails","ref":"Kalevala.Brain.ConditionalSelector.html","title":"Kalevala.Brain.ConditionalSelector","type":"module"},{"doc":"Condition check for the event being a message and the regex matches","ref":"Kalevala.Brain.Conditions.EventMatch.html","title":"Kalevala.Brain.Conditions.EventMatch","type":"module"},{"doc":"","ref":"Kalevala.Brain.Conditions.EventMatch.html#self_check/3","title":"Kalevala.Brain.Conditions.EventMatch.self_check/3","type":"function"},{"doc":"Condition check for the event being a message and the regex matches","ref":"Kalevala.Brain.Conditions.MessageMatch.html","title":"Kalevala.Brain.Conditions.MessageMatch","type":"module"},{"doc":"","ref":"Kalevala.Brain.Conditions.MessageMatch.html#self_check/3","title":"Kalevala.Brain.Conditions.MessageMatch.self_check/3","type":"function"},{"doc":"Match values in the meta map","ref":"Kalevala.Brain.Conditions.StateMatch.html","title":"Kalevala.Brain.Conditions.StateMatch","type":"module"},{"doc":"Processes each node one at a time and stops processing when the first one succeeds","ref":"Kalevala.Brain.FirstSelector.html","title":"Kalevala.Brain.FirstSelector","type":"module"},{"doc":"Process a node in the behavior tree","ref":"Kalevala.Brain.Node.html","title":"Kalevala.Brain.Node","type":"protocol"},{"doc":"","ref":"Kalevala.Brain.Node.html#run/3","title":"Kalevala.Brain.Node.run/3","type":"function"},{"doc":"","ref":"Kalevala.Brain.Node.html#t:t/0","title":"Kalevala.Brain.Node.t/0","type":"type"},{"doc":"A no-op node","ref":"Kalevala.Brain.NullNode.html","title":"Kalevala.Brain.NullNode","type":"module"},{"doc":"Processes a random node","ref":"Kalevala.Brain.RandomSelector.html","title":"Kalevala.Brain.RandomSelector","type":"module"},{"doc":"Process each node one at a time","ref":"Kalevala.Brain.Sequence.html","title":"Kalevala.Brain.Sequence","type":"module"},{"doc":"Keep state around a character&#39;s brain A key/value store that allows for expiring keys","ref":"Kalevala.Brain.State.html","title":"Kalevala.Brain.State","type":"module"},{"doc":"","ref":"Kalevala.Brain.State.html#clean/2","title":"Kalevala.Brain.State.clean/2","type":"function"},{"doc":"Get a key from the store","ref":"Kalevala.Brain.State.html#get/3","title":"Kalevala.Brain.State.get/3","type":"function"},{"doc":"Put a key in the store, with an optional expiration time","ref":"Kalevala.Brain.State.html#put/4","title":"Kalevala.Brain.State.put/4","type":"function"},{"doc":"Node to set meta values on a character","ref":"Kalevala.Brain.StateSet.html","title":"Kalevala.Brain.StateSet","type":"module"},{"doc":"Handle variable data in brain nodes Replaces variables in the format of ${variable_name}. Works with a dot notation for nested variables. Example: The starting data %{ channel_name: &quot;rooms:${room_id}&quot;, delay: 500, text: &quot;Welcome, ${character.name}!&quot; } With the event data %{ room_id: &quot;room-id&quot;, character: %{ name: &quot;Elias&quot; } } Will replace to the following %{ channel_name: &quot;rooms:room-id&quot;, delay: 500, text: &quot;Welcome, Elias!&quot; }","ref":"Kalevala.Brain.Variable.html","title":"Kalevala.Brain.Variable","type":"module"},{"doc":"Dereference a variable path from a map of data","ref":"Kalevala.Brain.Variable.html#dereference/2","title":"Kalevala.Brain.Variable.dereference/2","type":"function"},{"doc":"","ref":"Kalevala.Brain.Variable.html#dereference_variables/2","title":"Kalevala.Brain.Variable.dereference_variables/2","type":"function"},{"doc":"Detect variables inside of the data","ref":"Kalevala.Brain.Variable.html#detect_variables/2","title":"Kalevala.Brain.Variable.detect_variables/2","type":"function"},{"doc":"Replace action data variables with event data","ref":"Kalevala.Brain.Variable.html#replace/2","title":"Kalevala.Brain.Variable.replace/2","type":"function"},{"doc":"Replace detected and dereferenced variables in the data Fails if any variables still contain an :error value, they were not able to be dereferenced.","ref":"Kalevala.Brain.Variable.html#replace_variables/2","title":"Kalevala.Brain.Variable.replace_variables/2","type":"function"},{"doc":"Walk the resulting data map to convert keys from atoms to strings This is useful when sending the resulting data struct to action params","ref":"Kalevala.Brain.Variable.html#stringify_keys/1","title":"Kalevala.Brain.Variable.stringify_keys/1","type":"function"},{"doc":"Scan the value for a variable, returning Variable structs","ref":"Kalevala.Brain.Variable.html#variables/2","title":"Kalevala.Brain.Variable.variables/2","type":"function"},{"doc":"Test Helpers for testing a Brain struct","ref":"Kalevala.BrainTest.html","title":"Kalevala.BrainTest","type":"module"},{"doc":"Assert a value in the brain&#39;s state","ref":"Kalevala.BrainTest.html#assert_brain_value/3","title":"Kalevala.BrainTest.assert_brain_value/3","type":"macro"},{"doc":"GenServer for caching in game resources Example defmodule Kantele.World.Items do use Kalevala.Cache end iex&gt; Kalevala.Items.put(&quot;sammatti:sword&quot;, %Item{}) iex&gt; Kalevala.Items.get(&quot;sammatti:sword&quot;) %Item{}","ref":"Kalevala.Cache.html","title":"Kalevala.Cache","type":"behaviour"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Kalevala.Cache.html#child_spec/1","title":"Kalevala.Cache.child_spec/1","type":"function"},{"doc":"Get a value out of the cache","ref":"Kalevala.Cache.html#get/2","title":"Kalevala.Cache.get/2","type":"function"},{"doc":"Called after the cache is booted A chance to warm the cache before accepting outside updates.","ref":"Kalevala.Cache.html#c:initialize/1","title":"Kalevala.Cache.initialize/1","type":"callback"},{"doc":"Get a list of all keys in a table","ref":"Kalevala.Cache.html#keys/1","title":"Kalevala.Cache.keys/1","type":"function"},{"doc":"","ref":"Kalevala.Cache.html#keys/3","title":"Kalevala.Cache.keys/3","type":"function"},{"doc":"Put a new value into the cache","ref":"Kalevala.Cache.html#put/3","title":"Kalevala.Cache.put/3","type":"function"},{"doc":"","ref":"Kalevala.Cache.html#t:t/0","title":"Kalevala.Cache.t/0","type":"type"},{"doc":"Character struct Common data that all characters will have","ref":"Kalevala.Character.html","title":"Kalevala.Character","type":"module"},{"doc":"Generate a random ID","ref":"Kalevala.Character.html#generate_id/0","title":"Kalevala.Character.generate_id/0","type":"function"},{"doc":"Check if a keyword matches the character","ref":"Kalevala.Character.html#matches?/2","title":"Kalevala.Character.matches?/2","type":"function"},{"doc":"Actions are small character functionality bundled together For instance, you might have an action to speak into a room, or flee in a random direction.","ref":"Kalevala.Character.Action.html","title":"Kalevala.Character.Action","type":"behaviour"},{"doc":"","ref":"Kalevala.Character.Action.html#c:run/2","title":"Kalevala.Character.Action.run/2","type":"callback"},{"doc":"Commands handle player actions","ref":"Kalevala.Character.Command.html","title":"Kalevala.Character.Command","type":"module"},{"doc":"Sets up a module to be a command To create a dynamic command, which parses player text to determine if it matches: defmodule MyCommand do use Kalevala.Character.Command, dynamic: true end","ref":"Kalevala.Character.Command.html#__using__/1","title":"Kalevala.Character.Command.__using__/1","type":"macro"},{"doc":"A parsed dynamic command Generated from the dynamic command router DSL.","ref":"Kalevala.Character.Command.DynamicCommand.html","title":"Kalevala.Character.Command.DynamicCommand","type":"behaviour"},{"doc":"Called when parsing text from a user Options are passed through from the router.","ref":"Kalevala.Character.Command.DynamicCommand.html#c:parse/2","title":"Kalevala.Character.Command.DynamicCommand.parse/2","type":"callback"},{"doc":"A parsed command","ref":"Kalevala.Character.Command.ParsedCommand.html","title":"Kalevala.Character.Command.ParsedCommand","type":"module"},{"doc":"Parse player input to known commands","ref":"Kalevala.Character.Command.Router.html","title":"Kalevala.Character.Command.Router","type":"module"},{"doc":"Set of macros to build a command router using NimbleParsec","ref":"Kalevala.Character.Command.RouterMacros.html","title":"Kalevala.Character.Command.RouterMacros","type":"module"},{"doc":"Wraps NimbleParsec macros to generate a tagged command","ref":"Kalevala.Character.Command.RouterMacros.html#command/1","title":"Kalevala.Character.Command.RouterMacros.command/1","type":"macro"},{"doc":"Handle dynamic parsing This runs the parse/2 function on the given module at runtime. This enables parsing things against runtime only data.","ref":"Kalevala.Character.Command.RouterMacros.html#dynamic/3","title":"Kalevala.Character.Command.RouterMacros.dynamic/3","type":"macro"},{"doc":"","ref":"Kalevala.Character.Command.RouterMacros.html#generate_parse_function/5","title":"Kalevala.Character.Command.RouterMacros.generate_parse_function/5","type":"function"},{"doc":"Sets the @module tag for parse functions nested inside","ref":"Kalevala.Character.Command.RouterMacros.html#module/2","title":"Kalevala.Character.Command.RouterMacros.module/2","type":"macro"},{"doc":"Parse a new command command starts out the parse and any whitespace afterwards will be ignored","ref":"Kalevala.Character.Command.RouterMacros.html#parse/4","title":"Kalevala.Character.Command.RouterMacros.parse/4","type":"macro"},{"doc":"","ref":"Kalevala.Character.Command.RouterMacros.html#parse_dynamic_text/3","title":"Kalevala.Character.Command.RouterMacros.parse_dynamic_text/3","type":"function"},{"doc":"","ref":"Kalevala.Character.Command.RouterMacros.html#parse_text/4","title":"Kalevala.Character.Command.RouterMacros.parse_text/4","type":"function"},{"doc":"Wraps NimbleParsec macros to allow for grabbing spaces Grabs between other pieces of the command","ref":"Kalevala.Character.Command.RouterMacros.html#spaces/1","title":"Kalevala.Character.Command.RouterMacros.spaces/1","type":"macro"},{"doc":"","ref":"Kalevala.Character.Command.RouterMacros.html#symbol/2","title":"Kalevala.Character.Command.RouterMacros.symbol/2","type":"macro"},{"doc":"Wraps NimbleParsec macros to generate tagged text This grabs as much as it can","ref":"Kalevala.Character.Command.RouterMacros.html#text/2","title":"Kalevala.Character.Command.RouterMacros.text/2","type":"macro"},{"doc":"Wraps NimbleParsec macros to generate a tagged word Words are codepoints that don&#39;t include a space, or everything inside of quotes. Both of the following count as a word: villager &quot;town crier&quot;","ref":"Kalevala.Character.Command.RouterMacros.html#word/2","title":"Kalevala.Character.Command.RouterMacros.word/2","type":"macro"},{"doc":"Struct for tracking data being processed in a controller or command","ref":"Kalevala.Character.Conn.html","title":"Kalevala.Character.Conn","type":"module"},{"doc":"Add to the assignment map on the conn","ref":"Kalevala.Character.Conn.html#assign/3","title":"Kalevala.Character.Conn.assign/3","type":"function"},{"doc":"Get the character out of the conn If the character has been updated, this character will be returned","ref":"Kalevala.Character.Conn.html#character/2","title":"Kalevala.Character.Conn.character/2","type":"function"},{"doc":"Delay an event","ref":"Kalevala.Character.Conn.html#delay_event/4","title":"Kalevala.Character.Conn.delay_event/4","type":"function"},{"doc":"Send the foreman an in-game event","ref":"Kalevala.Character.Conn.html#event/3","title":"Kalevala.Character.Conn.event/3","type":"function"},{"doc":"Get a value out of the session data","ref":"Kalevala.Character.Conn.html#get_session/2","title":"Kalevala.Character.Conn.get_session/2","type":"function"},{"doc":"Mark the connection for termination","ref":"Kalevala.Character.Conn.html#halt/1","title":"Kalevala.Character.Conn.halt/1","type":"function"},{"doc":"Creates an even to move from one room to another","ref":"Kalevala.Character.Conn.html#move/6","title":"Kalevala.Character.Conn.move/6","type":"function"},{"doc":"Render a prompt to the conn","ref":"Kalevala.Character.Conn.html#prompt/4","title":"Kalevala.Character.Conn.prompt/4","type":"function"},{"doc":"Request to publish a message to a channel Available options for altering the message, these also get passed along to the channel callbacks. type, defaults to &quot;speech&quot; meta, defaults to %{}","ref":"Kalevala.Character.Conn.html#publish_message/5","title":"Kalevala.Character.Conn.publish_message/5","type":"function"},{"doc":"Put an action to be performed This should be a Kalevala.Character.Action struct to save which action module should be run, along with any delay and params.","ref":"Kalevala.Character.Conn.html#put_action/2","title":"Kalevala.Character.Conn.put_action/2","type":"function"},{"doc":"Update the character in state","ref":"Kalevala.Character.Conn.html#put_character/2","title":"Kalevala.Character.Conn.put_character/2","type":"function"},{"doc":"Put the new controller that the foreman should swap to","ref":"Kalevala.Character.Conn.html#put_controller/2","title":"Kalevala.Character.Conn.put_controller/2","type":"function"},{"doc":"Update a key in a character&#39;s meta map","ref":"Kalevala.Character.Conn.html#put_meta/3","title":"Kalevala.Character.Conn.put_meta/3","type":"function"},{"doc":"Put a value into the session data","ref":"Kalevala.Character.Conn.html#put_session/3","title":"Kalevala.Character.Conn.put_session/3","type":"function"},{"doc":"Render text to the conn","ref":"Kalevala.Character.Conn.html#render/4","title":"Kalevala.Character.Conn.render/4","type":"function"},{"doc":"Sends a request to drop an item into the room","ref":"Kalevala.Character.Conn.html#request_item_drop/2","title":"Kalevala.Character.Conn.request_item_drop/2","type":"function"},{"doc":"Sends a request to get an item from the room","ref":"Kalevala.Character.Conn.html#request_item_pickup/2","title":"Kalevala.Character.Conn.request_item_pickup/2","type":"function"},{"doc":"Request the room to move via the exit","ref":"Kalevala.Character.Conn.html#request_movement/2","title":"Kalevala.Character.Conn.request_movement/2","type":"function"},{"doc":"Send a telnet option","ref":"Kalevala.Character.Conn.html#send_option/3","title":"Kalevala.Character.Conn.send_option/3","type":"function"},{"doc":"Request to subscribe to a channel","ref":"Kalevala.Character.Conn.html#subscribe/4","title":"Kalevala.Character.Conn.subscribe/4","type":"function"},{"doc":"Request to unsubscribe from a channel","ref":"Kalevala.Character.Conn.html#unsubscribe/4","title":"Kalevala.Character.Conn.unsubscribe/4","type":"function"},{"doc":"","ref":"Kalevala.Character.Conn.html#t:t/0","title":"Kalevala.Character.Conn.t/0","type":"type"},{"doc":"Send an out of band Event","ref":"Kalevala.Character.Conn.Event.html","title":"Kalevala.Character.Conn.Event","type":"module"},{"doc":"An event that also includes text output Geared towards text suppression in the web client, to allow for text to be rendered for telnet and send an event in the web client.","ref":"Kalevala.Character.Conn.EventText.html","title":"Kalevala.Character.Conn.EventText","type":"module"},{"doc":"Receive an out of band event Telnet: via GMCP Websocket: anything not system/send","ref":"Kalevala.Character.Conn.IncomingEvent.html","title":"Kalevala.Character.Conn.IncomingEvent","type":"module"},{"doc":"Telnet option","ref":"Kalevala.Character.Conn.Option.html","title":"Kalevala.Character.Conn.Option","type":"module"},{"doc":"Struct to print text Used to determine if a new line should be sent before sending out new text.","ref":"Kalevala.Character.Conn.Text.html","title":"Kalevala.Character.Conn.Text","type":"module"},{"doc":"Kalevala controllers are the current set of actions for the user For instance, you might have a LoginController that handles authentication, that then passes to a CommandController to start processing player commands after they signed in.","ref":"Kalevala.Character.Controller.html","title":"Kalevala.Character.Controller","type":"behaviour"},{"doc":"Marks the module as a controller and imports controller functions","ref":"Kalevala.Character.Controller.html#__using__/1","title":"Kalevala.Character.Controller.__using__/1","type":"macro"},{"doc":"Called when a Kalevala.Character.Event.Display is sent to the foreman process","ref":"Kalevala.Character.Controller.html#c:display/2","title":"Kalevala.Character.Controller.display/2","type":"callback"},{"doc":"Called when a Kalevala.Character.Event is sent to the foreman process","ref":"Kalevala.Character.Controller.html#c:event/2","title":"Kalevala.Character.Controller.event/2","type":"callback"},{"doc":"Called when the controller is first switched to","ref":"Kalevala.Character.Controller.html#c:init/1","title":"Kalevala.Character.Controller.init/1","type":"callback"},{"doc":"Called when text is received from the player","ref":"Kalevala.Character.Controller.html#c:recv/2","title":"Kalevala.Character.Controller.recv/2","type":"callback"},{"doc":"Called when the connection receives an event (e.g. incoming GMCP)","ref":"Kalevala.Character.Controller.html#c:recv_event/2","title":"Kalevala.Character.Controller.recv_event/2","type":"callback"},{"doc":"Process events in the context of a character","ref":"Kalevala.Character.Event.html","title":"Kalevala.Character.Event","type":"module"},{"doc":"Session Foreman Manages data flowing from the player into the game.","ref":"Kalevala.Character.Foreman.html","title":"Kalevala.Character.Foreman","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Kalevala.Character.Foreman.html#child_spec/1","title":"Kalevala.Character.Foreman.child_spec/1","type":"function"},{"doc":"Handle the conn struct after processing","ref":"Kalevala.Character.Foreman.html#handle_conn/2","title":"Kalevala.Character.Foreman.handle_conn/2","type":"function"},{"doc":"Start a new foreman for a non-player (character run by the world)","ref":"Kalevala.Character.Foreman.html#start_non_player/1","title":"Kalevala.Character.Foreman.start_non_player/1","type":"function"},{"doc":"Start a new foreman for a connecting player","ref":"Kalevala.Character.Foreman.html#start_player/2","title":"Kalevala.Character.Foreman.start_player/2","type":"function"},{"doc":"","ref":"Kalevala.Character.Foreman.html#t:t/0","title":"Kalevala.Character.Foreman.t/0","type":"type"},{"doc":"Callbacks for a integrating with the character foreman process","ref":"Kalevala.Character.Foreman.Callbacks.html","title":"Kalevala.Character.Foreman.Callbacks","type":"behaviour"},{"doc":"Fill in state with any passed in options","ref":"Kalevala.Character.Foreman.Callbacks.html#c:init/2","title":"Kalevala.Character.Foreman.Callbacks.init/2","type":"callback"},{"doc":"Send options to a connection process","ref":"Kalevala.Character.Foreman.Callbacks.html#c:send_options/2","title":"Kalevala.Character.Foreman.Callbacks.send_options/2","type":"callback"},{"doc":"Send text to a connection process","ref":"Kalevala.Character.Foreman.Callbacks.html#c:send_output/2","title":"Kalevala.Character.Foreman.Callbacks.send_output/2","type":"callback"},{"doc":"Called when the foreman process is halted through a conn Perform whatever actions are required to start terminating.","ref":"Kalevala.Character.Foreman.Callbacks.html#c:terminate/1","title":"Kalevala.Character.Foreman.Callbacks.terminate/1","type":"callback"},{"doc":"The process is terminating from a :terminate message Perform whatever is required before terminating.","ref":"Kalevala.Character.Foreman.Callbacks.html#c:terminating/1","title":"Kalevala.Character.Foreman.Callbacks.terminating/1","type":"callback"},{"doc":"The character updated and presence should be tracked","ref":"Kalevala.Character.Foreman.Callbacks.html#c:track_presence/2","title":"Kalevala.Character.Foreman.Callbacks.track_presence/2","type":"callback"},{"doc":"Options for starting the foreman process","ref":"Kalevala.Character.Foreman.Callbacks.html#t:opts/0","title":"Kalevala.Character.Foreman.Callbacks.opts/0","type":"type"},{"doc":"","ref":"Kalevala.Character.Foreman.Callbacks.html#t:state/0","title":"Kalevala.Character.Foreman.Callbacks.state/0","type":"type"},{"doc":"Helpers for dealing with communication channels","ref":"Kalevala.Character.Foreman.Channel.html","title":"Kalevala.Character.Foreman.Channel","type":"module"},{"doc":"Handle any channel updates from the conn","ref":"Kalevala.Character.Foreman.Channel.html#handle_channels/2","title":"Kalevala.Character.Foreman.Channel.handle_channels/2","type":"function"},{"doc":"Callbacks for a non-player character","ref":"Kalevala.Character.Foreman.NonPlayer.html","title":"Kalevala.Character.Foreman.NonPlayer","type":"module"},{"doc":"Callbacks for a player character","ref":"Kalevala.Character.Foreman.Player.html","title":"Kalevala.Character.Foreman.Player","type":"module"},{"doc":"Supervisor for foreman processes","ref":"Kalevala.Character.Foreman.Supervisor.html","title":"Kalevala.Character.Foreman.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Kalevala.Character.Foreman.Supervisor.html#child_spec/1","title":"Kalevala.Character.Foreman.Supervisor.child_spec/1","type":"function"},{"doc":"Track the presence of online characters","ref":"Kalevala.Character.Presence.html","title":"Kalevala.Character.Presence","type":"behaviour"},{"doc":"Load all online characters","ref":"Kalevala.Character.Presence.html#characters/1","title":"Kalevala.Character.Presence.characters/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Kalevala.Character.Presence.html#child_spec/1","title":"Kalevala.Character.Presence.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Kalevala.Character.Presence.html#init/1","title":"Kalevala.Character.Presence.init/1","type":"function"},{"doc":"Notify the callback module that a character is offline","ref":"Kalevala.Character.Presence.html#c:offline/1","title":"Kalevala.Character.Presence.offline/1","type":"callback"},{"doc":"Notify the callback module that a character is online","ref":"Kalevala.Character.Presence.html#c:online/1","title":"Kalevala.Character.Presence.online/1","type":"callback"},{"doc":"Start tracking a character (and it&#39;s foreman process)","ref":"Kalevala.Character.Presence.html#track/2","title":"Kalevala.Character.Presence.track/2","type":"function"},{"doc":"Render output from the game","ref":"Kalevala.Character.View.html","title":"Kalevala.Character.View","type":"module"},{"doc":"&quot;Join&quot; an IO data list with a separator string Similar to Enum.join, but leaves as an IO data list","ref":"Kalevala.Character.View.html#join/2","title":"Kalevala.Character.View.join/2","type":"function"},{"doc":"Trim empty lines from io data Detects empty lines in io data (for example when rendered via EEx templating), and removes them. This way the template string works as expected, returning an empty string from a sub-render will strip the line.","ref":"Kalevala.Character.View.html#trim_lines/1","title":"Kalevala.Character.View.trim_lines/1","type":"function"},{"doc":"An EEx Engine that returns IO data instead of a string Taken from Phoenix.HTML.Engine","ref":"Kalevala.Character.View.EExKalevala.html","title":"Kalevala.Character.View.EExKalevala","type":"module"},{"doc":"Imported into views","ref":"Kalevala.Character.View.Macro.html","title":"Kalevala.Character.View.Macro","type":"module"},{"doc":"Creates ~E which runs through EEx templating","ref":"Kalevala.Character.View.Macro.html#sigil_E/2","title":"Kalevala.Character.View.Macro.sigil_E/2","type":"macro"},{"doc":"Creates ~i to create IO lists that look like standard interpolation","ref":"Kalevala.Character.View.Macro.html#sigil_i/2","title":"Kalevala.Character.View.Macro.sigil_i/2","type":"macro"},{"doc":"Handle communication for the game Register global channels, room channels, character channels, etc.","ref":"Kalevala.Communication.html","title":"Kalevala.Communication","type":"behaviour"},{"doc":"","ref":"Kalevala.Communication.html#c:initial_channels/0","title":"Kalevala.Communication.initial_channels/0","type":"callback"},{"doc":"Publish a message on a channel","ref":"Kalevala.Communication.html#publish/4","title":"Kalevala.Communication.publish/4","type":"function"},{"doc":"Register a new channel with a callback","ref":"Kalevala.Communication.html#register/4","title":"Kalevala.Communication.register/4","type":"function"},{"doc":"Subscribe the current PID to a channel","ref":"Kalevala.Communication.html#subscribe/4","title":"Kalevala.Communication.subscribe/4","type":"function"},{"doc":"Unsubscribe the current PID to a channel","ref":"Kalevala.Communication.html#unsubscribe/4","title":"Kalevala.Communication.unsubscribe/4","type":"function"},{"doc":"A local cache server for communication Tracks which channels are registered to which PID and which pids are subscribed to which channel.","ref":"Kalevala.Communication.Cache.html","title":"Kalevala.Communication.Cache","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Kalevala.Communication.Cache.html#child_spec/1","title":"Kalevala.Communication.Cache.child_spec/1","type":"function"},{"doc":"Register a new channel","ref":"Kalevala.Communication.Cache.html#register/4","title":"Kalevala.Communication.Cache.register/4","type":"function"},{"doc":"Get a list of all subscribers on a channel","ref":"Kalevala.Communication.Cache.html#subscribers/2","title":"Kalevala.Communication.Cache.subscribers/2","type":"function"},{"doc":"A GenServer to handle channel communication","ref":"Kalevala.Communication.Channel.html","title":"Kalevala.Communication.Channel","type":"behaviour"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Kalevala.Communication.Channel.html#child_spec/1","title":"Kalevala.Communication.Channel.child_spec/1","type":"function"},{"doc":"Called during initialization You can change any of the config you wish on start of the gen server","ref":"Kalevala.Communication.Channel.html#c:init/1","title":"Kalevala.Communication.Channel.init/1","type":"callback"},{"doc":"Publish a new message","ref":"Kalevala.Communication.Channel.html#publish/3","title":"Kalevala.Communication.Channel.publish/3","type":"function"},{"doc":"Called before a message is allowed to publish on the channel","ref":"Kalevala.Communication.Channel.html#c:publish_request/4","title":"Kalevala.Communication.Channel.publish_request/4","type":"callback"},{"doc":"Subscribe to a new channel Allows for the callback_module to reject subscription","ref":"Kalevala.Communication.Channel.html#subscribe/4","title":"Kalevala.Communication.Channel.subscribe/4","type":"function"},{"doc":"Called before a pid is allowed to subscribe to a channel","ref":"Kalevala.Communication.Channel.html#c:subscribe_request/3","title":"Kalevala.Communication.Channel.subscribe_request/3","type":"callback"},{"doc":"Unsubscribe to a new channel Allows for the callback_module to reject unsubscription","ref":"Kalevala.Communication.Channel.html#unsubscribe/4","title":"Kalevala.Communication.Channel.unsubscribe/4","type":"function"},{"doc":"Called before a pid is allowed to unsubscribe to a channel","ref":"Kalevala.Communication.Channel.html#c:unsubscribe_request/3","title":"Kalevala.Communication.Channel.unsubscribe_request/3","type":"callback"},{"doc":"The &quot;topic&quot; in the channel pub/sub This might be a simple global channel name or something specific to rooms, maybe rooms:id.","ref":"Kalevala.Communication.Channel.html#t:channel_name/0","title":"Kalevala.Communication.Channel.channel_name/0","type":"type"},{"doc":"Config is saved and stored in the GenServer, passed in for each callback","ref":"Kalevala.Communication.Channel.html#t:config/0","title":"Kalevala.Communication.Channel.config/0","type":"type"},{"doc":"Options are for each subscribe/publish request This may contain information like charcater data","ref":"Kalevala.Communication.Channel.html#t:options/0","title":"Kalevala.Communication.Channel.options/0","type":"type"},{"doc":"DynamicSupervisor for registering channels","ref":"Kalevala.Communication.Channels.html","title":"Kalevala.Communication.Channels","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Kalevala.Communication.Channels.html#child_spec/1","title":"Kalevala.Communication.Channels.child_spec/1","type":"function"},{"doc":"","ref":"Kalevala.Communication.Channels.html#start_child/4","title":"Kalevala.Communication.Channels.start_child/4","type":"function"},{"doc":"Test helpers for testing Controllers/Commands/Actions/etc","ref":"Kalevala.ConnTest.html","title":"Kalevala.ConnTest","type":"module"},{"doc":"Assert the expected actions match the actions stored in the conn This expects the order to match and have no extra actions in the actual_actions.","ref":"Kalevala.ConnTest.html#assert_actions/2","title":"Kalevala.ConnTest.assert_actions/2","type":"macro"},{"doc":"Build a simple conn struct for the character","ref":"Kalevala.ConnTest.html#build_conn/2","title":"Kalevala.ConnTest.build_conn/2","type":"function"},{"doc":"Generate an event struct","ref":"Kalevala.ConnTest.html#event/3","title":"Kalevala.ConnTest.event/3","type":"function"},{"doc":"An internal event","ref":"Kalevala.Event.html","title":"Kalevala.Event","type":"module"},{"doc":"Set the end time on an event","ref":"Kalevala.Event.html#set_end_time/1","title":"Kalevala.Event.set_end_time/1","type":"function"},{"doc":"Set the start time on an event","ref":"Kalevala.Event.html#set_start_time/1","title":"Kalevala.Event.set_start_time/1","type":"function"},{"doc":"Timing for an event in microseconds","ref":"Kalevala.Event.html#timing/1","title":"Kalevala.Event.timing/1","type":"function"},{"doc":"","ref":"Kalevala.Event.html#t:item_request_drop/0","title":"Kalevala.Event.item_request_drop/0","type":"type"},{"doc":"","ref":"Kalevala.Event.html#t:item_request_pickup/0","title":"Kalevala.Event.item_request_pickup/0","type":"type"},{"doc":"","ref":"Kalevala.Event.html#t:message/0","title":"Kalevala.Event.message/0","type":"type"},{"doc":"","ref":"Kalevala.Event.html#t:movement_request/0","title":"Kalevala.Event.movement_request/0","type":"type"},{"doc":"","ref":"Kalevala.Event.html#t:movement_voting/0","title":"Kalevala.Event.movement_voting/0","type":"type"},{"doc":"","ref":"Kalevala.Event.html#t:t/0","title":"Kalevala.Event.t/0","type":"type"},{"doc":"","ref":"Kalevala.Event.html#t:topic/0","title":"Kalevala.Event.topic/0","type":"type"},{"doc":"Struct for sending a message","ref":"Kalevala.Event.Delayed.html","title":"Kalevala.Event.Delayed","type":"module"},{"doc":"Turn a delayed event into a stanard event","ref":"Kalevala.Event.Delayed.html#to_event/1","title":"Kalevala.Event.Delayed.to_event/1","type":"function"},{"doc":"","ref":"Kalevala.Event.Delayed.html#t:t/0","title":"Kalevala.Event.Delayed.t/0","type":"type"},{"doc":"An event to display text/data back to the user","ref":"Kalevala.Event.Display.html","title":"Kalevala.Event.Display","type":"module"},{"doc":"Events to drop an item in a room In order to drop an item, send an ItemDrop.Request event with the item instance. The room will call the item_request_drop callback on the room module. Depending on the response, an Abort or Commit event will be sent.","ref":"Kalevala.Event.ItemDrop.html","title":"Kalevala.Event.ItemDrop","type":"module"},{"doc":"The request to drop an item was aborted by the room The item should be kept in the character&#39;s inventory.","ref":"Kalevala.Event.ItemDrop.Abort.html","title":"Kalevala.Event.ItemDrop.Abort","type":"module"},{"doc":"The request to drop an item was committed by the room The item should be removed from the character&#39;s inventory. The item is already in the room.","ref":"Kalevala.Event.ItemDrop.Commit.html","title":"Kalevala.Event.ItemDrop.Commit","type":"module"},{"doc":"Request to pick up an item from the room","ref":"Kalevala.Event.ItemDrop.Request.html","title":"Kalevala.Event.ItemDrop.Request","type":"module"},{"doc":"Events to pick up item in a room In order to pick up an item, send an ItemPickUp.Request event with the item name. The room will try to find the matching item(s) based on the matches?/2 callback on the item after loading them from instances in the room. After finding a matching item, the item_request_pickup callback is called on the room module. Depending on the response, an Abort or Commit event will be sent.","ref":"Kalevala.Event.ItemPickUp.html","title":"Kalevala.Event.ItemPickUp","type":"module"},{"doc":"The request to pick up an item was aborted by the room The item cannot be added to the character&#39;s room.","ref":"Kalevala.Event.ItemPickUp.Abort.html","title":"Kalevala.Event.ItemPickUp.Abort","type":"module"},{"doc":"The request to pick up an item was committed by the room The item should be added to the character&#39;s inventory. The item instance was is longer in the room.","ref":"Kalevala.Event.ItemPickUp.Commit.html","title":"Kalevala.Event.ItemPickUp.Commit","type":"module"},{"doc":"Request to pick up an item from the room","ref":"Kalevala.Event.ItemPickUp.Request.html","title":"Kalevala.Event.ItemPickUp.Request","type":"module"},{"doc":"Struct for sending a message","ref":"Kalevala.Event.Message.html","title":"Kalevala.Event.Message","type":"module"},{"doc":"Generate a random ID","ref":"Kalevala.Event.Message.html#generate_id/0","title":"Kalevala.Event.Message.generate_id/0","type":"function"},{"doc":"","ref":"Kalevala.Event.Message.html#t:t/0","title":"Kalevala.Event.Message.t/0","type":"type"},{"doc":"Metadata for an event, used for telemetry","ref":"Kalevala.Event.Metadata.html","title":"Kalevala.Event.Metadata","type":"module"},{"doc":"An event to move from one room to another","ref":"Kalevala.Event.Movement.html","title":"Kalevala.Event.Movement","type":"module"},{"doc":"A movement event character is the character performing the movement direction is one of two options, :to or :from, depending if the character is moving :to the room, or moving :from the room reason is what will be sent to other characters in the room and displayed (to players) room_id is the room the event is intended for","ref":"Kalevala.Event.Movement.html#t:t/0","title":"Kalevala.Event.Movement.t/0","type":"type"},{"doc":"Struct for aborting movement between two rooms","ref":"Kalevala.Event.Movement.Abort.html","title":"Kalevala.Event.Movement.Abort","type":"module"},{"doc":"Struct for committing movement between two rooms","ref":"Kalevala.Event.Movement.Commit.html","title":"Kalevala.Event.Movement.Commit","type":"module"},{"doc":"Event to send a notice to other characters in the room","ref":"Kalevala.Event.Movement.Notice.html","title":"Kalevala.Event.Movement.Notice","type":"module"},{"doc":"Character requesting to move from their current room in a exit_name A move request transitions through several stages before commiting or aborting. The character requests the room to move in a exit_name. %Kalevala.Event{ topic: Kalevala.Event.Movement.Request, data: %Kalevala.Event.Movement.Request{ character: character, exit_name: &quot;north&quot; } } The room process sends a voting event to the Zone after determining that there is a valid exit in this exit_name. %Kalevala.Event{ topic: Kalevala.Event.Movement.Voting, data: %Kalevala.Event.Movement.Voting{ character: character, from: start_room_id, to: end_room_id, exit_name: &quot;north&quot; } } The zone then asks the to and from room if they are OK with the character moving. Each room will be GenServer.called to block and keep this synchronous. The room movement/2 callback will be called for each room, so they can vote on the movement. Kalevala.Event.Movement.Commit - After both room&#39;s agree that the player can move, the zone sends this event to the character. %Kalevala.Event{ topic: Kalevala.Event.Movement.Commit, data: %Movement.Commit{ character: character, from: start_room_id, to: end_room_id, exit_name: &quot;north&quot; } } Kalevala.Event.Movement.Abort - If either room rejects the movement, the zone will respond with an abort. %Kalevala.Event{ topic: Kalevala.Event.Movement.Abort, data: %Kalevala.Event.Movement.Abort{ character: character, from: start_room_id, to: end_room_id, exit_name: &quot;north&quot;, reason: :door_locked } } %Kalevala.Event{ topic: Kalevala.Event.Movement.Abort, data: %Kalevala.Event.Movement.Abort{ character: character, from: start_room_id, exit_name: &quot;north&quot;, reason: :no_exit } } On a commit, the player leaves the old room, and enters the new one. %Kalevala.Event{ topic: Kalevala.Event.Movement, data: %Kalevala.Event.Movement{ character: character, direction: :to, reason: &quot;Player enters from the south.&quot; } } %Kalevala.Event{ topic: Kalevala.Event.Movement, data: %Kalevala.Event.Movement{ character: character, direction: :from, reason: &quot;Player leaves to the north.&quot; } }","ref":"Kalevala.Event.Movement.Request.html","title":"Kalevala.Event.Movement.Request","type":"module"},{"doc":"Signal that a character wishes to move to another location character is the character moving exit is the exit_name of the exit the player wants to move","ref":"Kalevala.Event.Movement.Request.html#t:t/0","title":"Kalevala.Event.Movement.Request.t/0","type":"type"},{"doc":"A voting event tracks the state of a character wishing to change rooms","ref":"Kalevala.Event.Movement.Voting.html","title":"Kalevala.Event.Movement.Voting","type":"module"},{"doc":"Generate an abort event after voting has occurred","ref":"Kalevala.Event.Movement.Voting.html#abort/1","title":"Kalevala.Event.Movement.Voting.abort/1","type":"function"},{"doc":"Generate a commit event after voting has occurred","ref":"Kalevala.Event.Movement.Voting.html#commit/1","title":"Kalevala.Event.Movement.Voting.commit/1","type":"function"},{"doc":"An event to allow for rooms to abort or commit the character moving. Each room has a chance to reject movement state is an enum, one of the following atoms: :request, :commit, or :abort character is the character performing the action to is the room the character is going towards from is the room the character is going away from exit_name is the name of the exit_name that the player is using reason is an atom such as :no_exit for why the movement is aborted","ref":"Kalevala.Event.Movement.Voting.html#t:t/0","title":"Kalevala.Event.Movement.Voting.t/0","type":"type"},{"doc":"Route in-game events Locates the appropriate module and function for a Kalevala.Event","ref":"Kalevala.Event.Router.html","title":"Kalevala.Event.Router","type":"behaviour"},{"doc":"Parse an input string with the conn as the context","ref":"Kalevala.Event.Router.html#c:call/3","title":"Kalevala.Event.Router.call/3","type":"callback"},{"doc":"Macro to generate the receive functions scope(App) do module(CombatEvent) do event(&quot;combat/start&quot;, :start) event(&quot;combat/stop&quot;, :stop) end end","ref":"Kalevala.Event.Router.html#scope/2","title":"Kalevala.Event.Router.scope/2","type":"macro"},{"doc":"Help Topics A cache for help topics that the user can look up.","ref":"Kalevala.Help.html","title":"Kalevala.Help","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Kalevala.Help.html#child_spec/1","title":"Kalevala.Help.child_spec/1","type":"function"},{"doc":"Get a help topic from the cache","ref":"Kalevala.Help.html#get/1","title":"Kalevala.Help.get/1","type":"function"},{"doc":"Put a topic in the cache","ref":"Kalevala.Help.html#put/1","title":"Kalevala.Help.put/1","type":"function"},{"doc":"Struct for help topics","ref":"Kalevala.Help.HelpTopic.html","title":"Kalevala.Help.HelpTopic","type":"module"},{"doc":"A small cache to be a lookup from keyword -&gt; help topic key","ref":"Kalevala.Help.KeywordCache.html","title":"Kalevala.Help.KeywordCache","type":"module"},{"doc":"Get a value from the cache","ref":"Kalevala.Help.KeywordCache.html#get/1","title":"Kalevala.Help.KeywordCache.get/1","type":"function"},{"doc":"Get a value from the cache Unwraps the tagged tuple, returns the direct value. Raises an error if the value is not already in the cache.","ref":"Kalevala.Help.KeywordCache.html#get!/1","title":"Kalevala.Help.KeywordCache.get!/1","type":"function"},{"doc":"Get all keys in the cache","ref":"Kalevala.Help.KeywordCache.html#keys/0","title":"Kalevala.Help.KeywordCache.keys/0","type":"function"},{"doc":"Put a value in the cache","ref":"Kalevala.Help.KeywordCache.html#put/2","title":"Kalevala.Help.KeywordCache.put/2","type":"function"},{"doc":"Trim extra metadata on an instance metadata","ref":"Kalevala.Meta.html","title":"Kalevala.Meta","type":"module"},{"doc":"","ref":"Kalevala.Meta.html#get/2","title":"Kalevala.Meta.get/2","type":"function"},{"doc":"","ref":"Kalevala.Meta.html#put/3","title":"Kalevala.Meta.put/3","type":"function"},{"doc":"Trim extra metadata on an instance metadata","ref":"Kalevala.Meta.html#trim/1","title":"Kalevala.Meta.trim/1","type":"function"},{"doc":"","ref":"Kalevala.Meta.Access.html","title":"Kalevala.Meta.Access","type":"protocol"},{"doc":"","ref":"Kalevala.Meta.Access.html#get/2","title":"Kalevala.Meta.Access.get/2","type":"function"},{"doc":"","ref":"Kalevala.Meta.Access.html#put/3","title":"Kalevala.Meta.Access.put/3","type":"function"},{"doc":"","ref":"Kalevala.Meta.Access.html#t:t/0","title":"Kalevala.Meta.Access.t/0","type":"type"},{"doc":"Protocol for dealing with extra metadata on an instance from Kalevala","ref":"Kalevala.Meta.Trim.html","title":"Kalevala.Meta.Trim","type":"protocol"},{"doc":"Trim metadata down to fields that should be publicly accessible These will be included when being sent around in events","ref":"Kalevala.Meta.Trim.html#trim/1","title":"Kalevala.Meta.Trim.trim/1","type":"function"},{"doc":"","ref":"Kalevala.Meta.Trim.html#t:t/0","title":"Kalevala.Meta.Trim.t/0","type":"type"},{"doc":"Struct to tag trimmed metadata as already trimmed","ref":"Kalevala.Meta.Trimmed.html","title":"Kalevala.Meta.Trimmed","type":"module"},{"doc":"An output post processor for text from Kalevala Allow the game to modify text leaving Kalevala, such as to insert ANSI codes for color.","ref":"Kalevala.Output.html","title":"Kalevala.Output","type":"behaviour"},{"doc":"","ref":"Kalevala.Output.html#c:init/1","title":"Kalevala.Output.init/1","type":"callback"},{"doc":"","ref":"Kalevala.Output.html#c:parse/2","title":"Kalevala.Output.parse/2","type":"callback"},{"doc":"","ref":"Kalevala.Output.html#parse/3","title":"Kalevala.Output.parse/3","type":"function"},{"doc":"","ref":"Kalevala.Output.html#c:post_parse/1","title":"Kalevala.Output.post_parse/1","type":"callback"},{"doc":"","ref":"Kalevala.Output.html#process/3","title":"Kalevala.Output.process/3","type":"function"},{"doc":"Context struct for an output callback module","ref":"Kalevala.Output.Context.html","title":"Kalevala.Output.Context","type":"module"},{"doc":"Remove any open and close tag tuples from the data","ref":"Kalevala.Output.StripTags.html","title":"Kalevala.Output.StripTags","type":"module"},{"doc":"Process table tags into ANSI tables Processes 3 tags, {table}, {row}, and {cell}. Tables are automatically balanced and text in cells are centered. Example table: {table} {row} {cell}Player Name{/cell} {/row} {row} {cell}HP{/cell} {cell}{color foreground=&quot;red&quot;}50/50{/color}{/cell} {/row} {/table} {table} Tag This tag starts a new table. It can only contain {row} tags as children. Any whitespace is trimmed and ignored inside the table. {row} Tag This tag starts a new row. It can only contain {cell} tags as children. Any whitespace is trimmed and ignored inside the row. {cell} Tag This tag is a cell. It can contain strings and other tags that don&#39;t increase the width of the cell, e.g. color tags. Anything other than a string is not used to calculate the width of the cell, which is used for balacing the table.","ref":"Kalevala.Output.Tables.html","title":"Kalevala.Output.Tables","type":"module"},{"doc":"Build a list of padding spaces for a side of a cell","ref":"Kalevala.Output.Tables.html#cell_padding/1","title":"Kalevala.Output.Tables.cell_padding/1","type":"function"},{"doc":"Display a cell&#39;s contents Pads the left and right, &quot;pulls&quot; left when centering (if an odd number)","ref":"Kalevala.Output.Tables.html#display_cells/2","title":"Kalevala.Output.Tables.display_cells/2","type":"function"},{"doc":"Display a row&#39;s cells","ref":"Kalevala.Output.Tables.html#display_row/3","title":"Kalevala.Output.Tables.display_row/3","type":"function"},{"doc":"Display a table","ref":"Kalevala.Output.Tables.html#display_rows/1","title":"Kalevala.Output.Tables.display_rows/1","type":"function"},{"doc":"Find the max width of rows in a table","ref":"Kalevala.Output.Tables.html#max_width/1","title":"Kalevala.Output.Tables.max_width/1","type":"function"},{"doc":"Get the total width of a row Each cell tracks it&#39;s string width, plus 3 for built in padding","ref":"Kalevala.Output.Tables.html#row_width/1","title":"Kalevala.Output.Tables.row_width/1","type":"function"},{"doc":"Give table tags some &quot;breathing&quot; room If there is text before the table and no newline, then make a new line If there is text after the table and no newline, then make a new line","ref":"Kalevala.Output.Tables.html#table_breathing_room/1","title":"Kalevala.Output.Tables.table_breathing_room/1","type":"function"},{"doc":"Validate cells in a row (are all cell tags)","ref":"Kalevala.Output.Tables.html#valid_cells?/1","title":"Kalevala.Output.Tables.valid_cells?/1","type":"function"},{"doc":"Validate rows in a table (are all row tags and have valid cells)","ref":"Kalevala.Output.Tables.html#valid_rows?/1","title":"Kalevala.Output.Tables.valid_rows?/1","type":"function"},{"doc":"Process color tags into ANSI escape codes","ref":"Kalevala.Output.TagColors.html","title":"Kalevala.Output.TagColors","type":"module"},{"doc":"","ref":"Kalevala.Output.TagColors.html#background_color/1","title":"Kalevala.Output.TagColors.background_color/1","type":"function"},{"doc":"","ref":"Kalevala.Output.TagColors.html#foreground_color/1","title":"Kalevala.Output.TagColors.foreground_color/1","type":"function"},{"doc":"","ref":"Kalevala.Output.TagColors.html#process_close_tag/1","title":"Kalevala.Output.TagColors.process_close_tag/1","type":"function"},{"doc":"","ref":"Kalevala.Output.TagColors.html#process_tag/1","title":"Kalevala.Output.TagColors.process_tag/1","type":"function"},{"doc":"","ref":"Kalevala.Output.TagColors.html#underline/1","title":"Kalevala.Output.TagColors.underline/1","type":"function"},{"doc":"Output processor that parses tags","ref":"Kalevala.Output.Tags.html","title":"Kalevala.Output.Tags","type":"module"},{"doc":"Escape special tag characters in a string To prevent characters from using these tags in commands","ref":"Kalevala.Output.Tags.html#escape/1","title":"Kalevala.Output.Tags.escape/1","type":"function"},{"doc":"","ref":"Kalevala.Output.Tags.html#parse_string/4","title":"Kalevala.Output.Tags.parse_string/4","type":"function"},{"doc":"","ref":"Kalevala.Output.Tags.html#parse_tag/1","title":"Kalevala.Output.Tags.parse_tag/1","type":"function"},{"doc":"","ref":"Kalevala.Output.Tags.html#parse_tag_attributes/1","title":"Kalevala.Output.Tags.parse_tag_attributes/1","type":"function"},{"doc":"Processes tags for the websocket output Finds matching opening and closing tags and groups children together","ref":"Kalevala.Output.Websocket.html","title":"Kalevala.Output.Websocket","type":"module"},{"doc":"Process that starts the ranch listener","ref":"Kalevala.Telnet.Listener.html","title":"Kalevala.Telnet.Listener","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Kalevala.Telnet.Listener.html#child_spec/1","title":"Kalevala.Telnet.Listener.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.handle_continue/2.","ref":"Kalevala.Telnet.Listener.html#handle_continue/2","title":"Kalevala.Telnet.Listener.handle_continue/2","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Kalevala.Telnet.Listener.html#init/1","title":"Kalevala.Telnet.Listener.init/1","type":"function"},{"doc":"","ref":"Kalevala.Telnet.Listener.html#start_link/1","title":"Kalevala.Telnet.Listener.start_link/1","type":"function"},{"doc":"ranch protocol for handling telnet connection","ref":"Kalevala.Telnet.Protocol.html","title":"Kalevala.Telnet.Protocol","type":"module"},{"doc":"","ref":"Kalevala.Telnet.Protocol.html#handle_continue/2","title":"Kalevala.Telnet.Protocol.handle_continue/2","type":"function"},{"doc":"","ref":"Kalevala.Telnet.Protocol.html#handle_info/2","title":"Kalevala.Telnet.Protocol.handle_info/2","type":"function"},{"doc":"A verb is a discrete action that the player may perform Things like picking up or dropping items, stealing, etc.","ref":"Kalevala.Verb.html","title":"Kalevala.Verb","type":"module"},{"doc":"Check if a list of verbs contains a verb that matches the context","ref":"Kalevala.Verb.html#has_matching_verb?/3","title":"Kalevala.Verb.has_matching_verb?/3","type":"function"},{"doc":"Check if a verb matches the context","ref":"Kalevala.Verb.html#matches?/2","title":"Kalevala.Verb.matches?/2","type":"function"},{"doc":"Check if the location condition matches the context No location condition == all locations are good iex&gt; Verb.matches_location?(%{location: [&quot;room&quot;]}, %{location: &quot;room&quot;}) true iex&gt; Verb.matches_location?(%{location: [&quot;inventory/self&quot;]}, %{location: &quot;inventory/self&quot;}) true iex&gt; Verb.matches_location?(%{location: [&quot;inventory&quot;]}, %{location: &quot;inventory/self&quot;}) true","ref":"Kalevala.Verb.html#matches_location?/2","title":"Kalevala.Verb.matches_location?/2","type":"function"},{"doc":"","ref":"Kalevala.Verb.html#replace_variables/2","title":"Kalevala.Verb.replace_variables/2","type":"function"},{"doc":"A verb is not allowed unless all conditions are met location is an array of all allowed locations, one must match","ref":"Kalevala.Verb.Conditions.html","title":"Kalevala.Verb.Conditions","type":"module"},{"doc":"Context for running a verb location where the verb is taking place","ref":"Kalevala.Verb.Context.html","title":"Kalevala.Verb.Context","type":"module"},{"doc":"Cowboy websocket handler Starts a foreman process tied to this websocket connection","ref":"Kalevala.Websocket.Handler.html","title":"Kalevala.Websocket.Handler","type":"module"},{"doc":"","ref":"Kalevala.Websocket.Handler.html#handle_in/2","title":"Kalevala.Websocket.Handler.handle_in/2","type":"function"},{"doc":"Start a cowboy listener","ref":"Kalevala.Websocket.Listener.html","title":"Kalevala.Websocket.Listener","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Kalevala.Websocket.Listener.html#child_spec/1","title":"Kalevala.Websocket.Listener.child_spec/1","type":"function"},{"doc":"Callback implementation for Supervisor.init/1.","ref":"Kalevala.Websocket.Listener.html#init/1","title":"Kalevala.Websocket.Listener.init/1","type":"function"},{"doc":"","ref":"Kalevala.Websocket.Listener.html#start_link/1","title":"Kalevala.Websocket.Listener.start_link/1","type":"function"},{"doc":"Manages the virtual world","ref":"Kalevala.World.html","title":"Kalevala.World","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Kalevala.World.html#child_spec/1","title":"Kalevala.World.child_spec/1","type":"function"},{"doc":"Start a world character into the world","ref":"Kalevala.World.html#start_character/2","title":"Kalevala.World.start_character/2","type":"function"},{"doc":"Start the room into the world","ref":"Kalevala.World.html#start_room/3","title":"Kalevala.World.start_room/3","type":"function"},{"doc":"Start the zone into the world","ref":"Kalevala.World.html#start_zone/2","title":"Kalevala.World.start_zone/2","type":"function"},{"doc":"A basic room These are the minimum fields a room should have. You likely want more, so we have a protocol Kalevala.World.Room.Callbacks to let you create your own local struct. The following functions provide default implementations you can use for the defimpl of that protocol. defimpl Kalevala.World.Room.Callbacks do alias Kalevala.World.BasicRoom @impl true def movement_request(_room, context, event, room_exit), do: BasicRoom.movement_request(context, event, room_exit) @impl true def confirm_movement(_room, context, event), do: BasicRoom.confirm_movement(context, event) @impl true def item_request_drop(_room, context, event, item_instance), do: BasicRoom.item_request_drop(context, event, item_instance) @impl true def item_request_pickup(_room, context, event, item_instance), do: BasicRoom.item_request_pickup(context, event, item_instance) # ... end","ref":"Kalevala.World.BasicRoom.html","title":"Kalevala.World.BasicRoom","type":"module"},{"doc":"","ref":"Kalevala.World.BasicRoom.html#confirm_movement/2","title":"Kalevala.World.BasicRoom.confirm_movement/2","type":"function"},{"doc":"","ref":"Kalevala.World.BasicRoom.html#item_request_drop/3","title":"Kalevala.World.BasicRoom.item_request_drop/3","type":"function"},{"doc":"","ref":"Kalevala.World.BasicRoom.html#item_request_pickup/3","title":"Kalevala.World.BasicRoom.item_request_pickup/3","type":"function"},{"doc":"","ref":"Kalevala.World.BasicRoom.html#movement_request/3","title":"Kalevala.World.BasicRoom.movement_request/3","type":"function"},{"doc":"A basic Zone These are the minimum fields a zone should have. You likely want more, so you can create your own local struct with these and more fields.","ref":"Kalevala.World.BasicZone.html","title":"Kalevala.World.BasicZone","type":"module"},{"doc":"Supervisor to watch over Residents","ref":"Kalevala.World.CharacterSupervisor.html","title":"Kalevala.World.CharacterSupervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Kalevala.World.CharacterSupervisor.html#child_spec/1","title":"Kalevala.World.CharacterSupervisor.child_spec/1","type":"function"},{"doc":"Exits link rooms together in one exit_name To link rooms together, create exits in both exit_names","ref":"Kalevala.World.Exit.html","title":"Kalevala.World.Exit","type":"module"},{"doc":"","ref":"Kalevala.World.Exit.html#t:t/0","title":"Kalevala.World.Exit.t/0","type":"type"},{"doc":"Item struct Common data that all items will have","ref":"Kalevala.World.Item.html","title":"Kalevala.World.Item","type":"behaviour"},{"doc":"Filter the item&#39;s verbs based on the current context","ref":"Kalevala.World.Item.html#context_verbs/2","title":"Kalevala.World.Item.context_verbs/2","type":"function"},{"doc":"Match a string against the item","ref":"Kalevala.World.Item.html#c:matches?/2","title":"Kalevala.World.Item.matches?/2","type":"callback"},{"doc":"","ref":"Kalevala.World.Item.html#t:t/0","title":"Kalevala.World.Item.t/0","type":"type"},{"doc":"Item instance struct A specific instance of an item in the world","ref":"Kalevala.World.Item.Instance.html","title":"Kalevala.World.Item.Instance","type":"module"},{"doc":"Generate a random instance ID","ref":"Kalevala.World.Item.Instance.html#generate_id/0","title":"Kalevala.World.Item.Instance.generate_id/0","type":"function"},{"doc":"","ref":"Kalevala.World.Item.Instance.html#t:t/0","title":"Kalevala.World.Item.Instance.t/0","type":"type"},{"doc":"An empty struct for item instances to include by default To know that the item is not loaded and you should load it","ref":"Kalevala.World.Item.ItemNotLoaded.html","title":"Kalevala.World.Item.ItemNotLoaded","type":"module"},{"doc":"Rooms are the base unit of space in Kalevala","ref":"Kalevala.World.Room.html","title":"Kalevala.World.Room","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Kalevala.World.Room.html#child_spec/1","title":"Kalevala.World.Room.child_spec/1","type":"function"},{"doc":"Confirm movement for a character","ref":"Kalevala.World.Room.html#confirm_movement/2","title":"Kalevala.World.Room.confirm_movement/2","type":"function"},{"doc":"Replace internal room state","ref":"Kalevala.World.Room.html#update/2","title":"Kalevala.World.Room.update/2","type":"function"},{"doc":"Replace internal room items state","ref":"Kalevala.World.Room.html#update_items/2","title":"Kalevala.World.Room.update_items/2","type":"function"},{"doc":"","ref":"Kalevala.World.Room.Callbacks.html","title":"Kalevala.World.Room.Callbacks","type":"protocol"},{"doc":"Callback for confirming or aborting character movement Called while the Zone is checking each side of the exit to know if the movement is indeed allowed. Returning the original event allows movement to proceed, otherwise return an aborted event to prevent movement. Hook to allow for the room to reject movement for custom reasons, e.g. an NPC is blocking the exit and needs to be convinced first, or there is a trap blocking the exit.","ref":"Kalevala.World.Room.Callbacks.html#confirm_movement/3","title":"Kalevala.World.Room.Callbacks.confirm_movement/3","type":"function"},{"doc":"Callback for when a new event is received","ref":"Kalevala.World.Room.Callbacks.html#event/3","title":"Kalevala.World.Room.Callbacks.event/3","type":"function"},{"doc":"Load the exits for a given room Used when a character is trying to move, the appropriate exit is chosen and forwarded into movement request callbacks. Since this is a common thing that will happen 99% of the time, Kalevala handles it.","ref":"Kalevala.World.Room.Callbacks.html#exits/1","title":"Kalevala.World.Room.Callbacks.exits/1","type":"function"},{"doc":"Called when the room is initializing","ref":"Kalevala.World.Room.Callbacks.html#init/1","title":"Kalevala.World.Room.Callbacks.init/1","type":"function"},{"doc":"Called after the room process is started Directly after init is completed.","ref":"Kalevala.World.Room.Callbacks.html#initialized/1","title":"Kalevala.World.Room.Callbacks.initialized/1","type":"function"},{"doc":"Callback for allowing an item drop off A character is requesting to pick up an item, this let&#39;s the room accept or reject the request.","ref":"Kalevala.World.Room.Callbacks.html#item_request_drop/4","title":"Kalevala.World.Room.Callbacks.item_request_drop/4","type":"function"},{"doc":"Callback for allowing an item pick up A character is requesting to pick up an item, this let&#39;s the room accept or reject the request.","ref":"Kalevala.World.Room.Callbacks.html#item_request_pickup/4","title":"Kalevala.World.Room.Callbacks.item_request_pickup/4","type":"function"},{"doc":"Convert item instances into items","ref":"Kalevala.World.Room.Callbacks.html#load_item/2","title":"Kalevala.World.Room.Callbacks.load_item/2","type":"function"},{"doc":"Callback for the room to hook into movement between exits The character is requesting to move via an exit, a tuple allowing or rejecting the movement before being pitched up to the Zone should be returned. Can immediately terminate a room before being checked in a more detailed fashion with confirm_movement/2 below.","ref":"Kalevala.World.Room.Callbacks.html#movement_request/4","title":"Kalevala.World.Room.Callbacks.movement_request/4","type":"function"},{"doc":"","ref":"Kalevala.World.Room.Callbacks.html#t:t/0","title":"Kalevala.World.Room.Callbacks.t/0","type":"type"},{"doc":"Context for performing work for an event in a room","ref":"Kalevala.World.Room.Context.html","title":"Kalevala.World.Room.Context","type":"module"},{"doc":"Add to the assignment map on the context","ref":"Kalevala.World.Room.Context.html#assign/3","title":"Kalevala.World.Room.Context.assign/3","type":"function"},{"doc":"Send an event back to a pid","ref":"Kalevala.World.Room.Context.html#event/5","title":"Kalevala.World.Room.Context.event/5","type":"function"},{"doc":"Handle context after processing an event","ref":"Kalevala.World.Room.Context.html#handle_context/1","title":"Kalevala.World.Room.Context.handle_context/1","type":"function"},{"doc":"Create a new context struct from room state","ref":"Kalevala.World.Room.Context.html#new/1","title":"Kalevala.World.Room.Context.new/1","type":"function"},{"doc":"Render a prompt back to a pid","ref":"Kalevala.World.Room.Context.html#prompt/5","title":"Kalevala.World.Room.Context.prompt/5","type":"function"},{"doc":"Render text back to a pid","ref":"Kalevala.World.Room.Context.html#render/5","title":"Kalevala.World.Room.Context.render/5","type":"function"},{"doc":"","ref":"Kalevala.World.Room.Context.html#t:t/0","title":"Kalevala.World.Room.Context.t/0","type":"type"},{"doc":"Module for handling room events","ref":"Kalevala.World.Room.Events.html","title":"Kalevala.World.Room.Events","type":"module"},{"doc":"Process events in a room","ref":"Kalevala.World.Room.Events.html#handle_event/2","title":"Kalevala.World.Room.Events.handle_event/2","type":"function"},{"doc":"A room feature is a highlighted part of a room","ref":"Kalevala.World.Room.Feature.html","title":"Kalevala.World.Room.Feature","type":"module"},{"doc":"Handle item pickup","ref":"Kalevala.World.Room.Item.html","title":"Kalevala.World.Room.Item","type":"module"},{"doc":"Handle a request for dropping an item","ref":"Kalevala.World.Room.Item.html#handle_drop_request/3","title":"Kalevala.World.Room.Item.handle_drop_request/3","type":"function"},{"doc":"Handle a request for picking up an item","ref":"Kalevala.World.Room.Item.html#handle_pickup_request/3","title":"Kalevala.World.Room.Item.handle_pickup_request/3","type":"function"},{"doc":"Handle room movement","ref":"Kalevala.World.Room.Movement.html","title":"Kalevala.World.Room.Movement","type":"module"},{"doc":"Broadcast the event to characters in the room","ref":"Kalevala.World.Room.Movement.html#broadcast/2","title":"Kalevala.World.Room.Movement.broadcast/2","type":"function"},{"doc":"Handle the movement event","ref":"Kalevala.World.Room.Movement.html#handle_event/2","title":"Kalevala.World.Room.Movement.handle_event/2","type":"function"},{"doc":"Handle the movement request If an abort, forward to the character Otherwise, Forward to the zone","ref":"Kalevala.World.Room.Movement.html#handle_request/3","title":"Kalevala.World.Room.Movement.handle_request/3","type":"function"},{"doc":"Store private information for a room, e.g. characters in the room","ref":"Kalevala.World.Room.Private.html","title":"Kalevala.World.Room.Private","type":"module"},{"doc":"Supervisor to watch over Rooms","ref":"Kalevala.World.RoomSupervisor.html","title":"Kalevala.World.RoomSupervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Kalevala.World.RoomSupervisor.html#child_spec/1","title":"Kalevala.World.RoomSupervisor.child_spec/1","type":"function"},{"doc":"Zones group together Rooms into a logical space","ref":"Kalevala.World.Zone.html","title":"Kalevala.World.Zone","type":"behaviour"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Kalevala.World.Zone.html#child_spec/1","title":"Kalevala.World.Zone.child_spec/1","type":"function"},{"doc":"Called when the zone is initializing","ref":"Kalevala.World.Zone.html#c:init/1","title":"Kalevala.World.Zone.init/1","type":"callback"},{"doc":"Replace internal zone state","ref":"Kalevala.World.Zone.html#update/2","title":"Kalevala.World.Zone.update/2","type":"function"},{"doc":"","ref":"Kalevala.World.Zone.html#t:t/0","title":"Kalevala.World.Zone.t/0","type":"type"},{"doc":"Zone movement functions","ref":"Kalevala.World.Zone.Movement.html","title":"Kalevala.World.Zone.Movement","type":"module"},{"doc":"","ref":"Kalevala.World.Zone.Movement.html#handle_voting/1","title":"Kalevala.World.Zone.Movement.handle_voting/1","type":"function"},{"doc":"Supervisor to watch over Zones","ref":"Kalevala.World.ZoneSupervisor.html","title":"Kalevala.World.ZoneSupervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Kalevala.World.ZoneSupervisor.html#child_spec/1","title":"Kalevala.World.ZoneSupervisor.child_spec/1","type":"function"},{"doc":"Generate files for a new command (command / event / views)","ref":"Mix.Tasks.Kalevala.Gen.Command.html","title":"Mix.Tasks.Kalevala.Gen.Command","type":"task"},{"doc":"","ref":"Mix.Tasks.Kalevala.Gen.Command.html#command_template/2","title":"Mix.Tasks.Kalevala.Gen.Command.command_template/2","type":"function"},{"doc":"","ref":"Mix.Tasks.Kalevala.Gen.Command.html#event_template/2","title":"Mix.Tasks.Kalevala.Gen.Command.event_template/2","type":"function"},{"doc":"","ref":"Mix.Tasks.Kalevala.Gen.Command.html#generate_file/2","title":"Mix.Tasks.Kalevala.Gen.Command.generate_file/2","type":"function"},{"doc":"Callback implementation for Mix.Task.run/1.","ref":"Mix.Tasks.Kalevala.Gen.Command.html#run/1","title":"Mix.Tasks.Kalevala.Gen.Command.run/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Kalevala.Gen.Command.html#view_template/2","title":"Mix.Tasks.Kalevala.Gen.Command.view_template/2","type":"function"},{"doc":"Kalevala Kalevala is a world building toolkit for text based games, written in Elixir.","ref":"readme.html","title":"Kalevala","type":"extras"},{"doc":"There is an example game, Kantele, in the example/ folder. To start the game: cd example/ mix deps.get mix compile cd assets/ yarn install yarn build cd .. mix run --no-halt A telnet listener will start on port 4444 and a TLS listener will start on port 4443 with a self signed cert. A web client will start on port 4500, visit http://localhost:4500/ to view it in your browser.","ref":"readme.html#example-game","title":"Kalevala - Example Game","type":"extras"},{"doc":"Foreman When you connect, a new Kalevala.Character.Foreman process is started. This process handles incoming text from the player, sending out going text and events, and other orchestration. Conn A Kalevala.Character.Conn is the context token for controllers and commands. This is similar to a Plug.Conn. The main difference being it bundles up multiple renders and events to fire all at once, instead of being used for a single request. The foreman will generate new Conns before each event or incoming text. After processing the Conn, it is processed by sending text to the player and events sent to their router (more on this in a bit). Controllers A Kalevala.Character.Controller is the largest building block of handling texting. When starting the foreman, an initial controller is given. This controller is initialized and used from then on. The callbacks required will be called at the appropriate time with a new Conn. Controllers act as a simple state machine, only allowing transitioning to the next one you set in the Conn. For instance, you can contain all login logic in a LoginController, and handle game commands in its own controller, any paging can be handled in a PagerController which can suppress any outgoing text to prevent scrolling while reading, etc. defmodule Kantele.Character.CommandController do use Kalevala.Character.Controller require Logger alias Kantele.Character.Commands alias Kantele.Character.CommandView @impl true def init(conn), do: prompt(conn, CommandView, &quot;prompt&quot;, %{}) @impl true def recv(conn, &quot;&quot;), do: conn def recv(conn, data) do Logger.info(&quot;Received - \#{inspect(data)}&quot;) case Commands.call(conn, data) do {:error, :unknown} -&gt; conn |&gt; render(CommandView, &quot;unknown&quot;, %{}) |&gt; prompt(CommandView, &quot;prompt&quot;, %{}) conn -&gt; prompt(conn, CommandView, &quot;prompt&quot;, %{}) end end end Commands A Kalevala.Character.Command is similar to a Controller, but should be called from a Controller through a Command.Router. Incoming text can be pattern matched in the router and be processed. In the example below, you can Kantele.Character.Commands.call(conn, &quot;say hello&quot;) to run the SayCommand.run/2 function. defmodule Kantele.Character.Commands do use Kalevala.Character.Commands.Router, scope: Kantele module(SayCommand) do parse(&quot;say&quot;, :run, fn command -&gt; command |&gt; spaces() |&gt; text(:message) end) end end defmodule Kantele.Character.SayCommand do use Kalevala.Character.Command def run(conn, params) do params = %{ &quot;name&quot; =&gt; character(conn).name, &quot;message&quot; =&gt; params[&quot;message&quot;] } conn |&gt; render(SayView, &quot;echo&quot;, params) |&gt; event(&quot;room/say&quot;, params) end end Views A Kalevala.Character.View renders text and out of band events to the player. These are strings, IO data lists, or Kalevala.Character.Conn.Event structs (which are used for GMCP in telnet.) The sigil ~i keeps a string as an IO data list, which is faster for processing and should be used if any interpolation is needed. Larger views can use the sigil ~E to use EEx. defmodule Kantele.Character.SayView do use Kalevala.Character.View import IO.ANSI, only: [reset: 0, white: 0] def render(&quot;echo&quot;, %{&quot;message&quot; =&gt; message}) do ~i(You say, &quot;\\e[32m\#{message}\\e[0m&quot;\\n) end def render(&quot;listen&quot;, %{&quot;character_name&quot; =&gt; character_name, &quot;message&quot; =&gt; message}) do ~i(\#{white()}\#{character_name}\#{reset()} says, &quot;\\e[32m\#{message}\\e[0m&quot;\\n) end end Events A Kalevala.Event is an internal event passed between processes. Events have three fields, which pid is generating the event, the topic (e.g. room/say), and a map of data. Controllers and commands can generate events which will get sent to an event router process, which is typically the room they are in. The Kalevala.World.Room process handles the event by running the event through a similar router to command processing. The Foreman process handles events with its own event router. In the example below, you can call the event router with an event of topic room/say to run the Kantele.World.Room.NotifyEvent.call/2 function. defmodule Kantele.World.Room.Events do @moduledoc false use Kalevala.Event.Router scope(Kantele.World.Room) do module(NotifyEvent) do event(&quot;room/say&quot;, :call) end end end defmodule Kantele.World.Room.NotifyEvent do import Kalevala.World.Room.Context def call(context, event) do Enum.reduce(context.characters, context, fn character, context -&gt; event(context, character.pid, event.from_pid, event.topic, event.data) end) end end Actions A Kalevala.Character.Action is a small set of functionality that a character can perform. Think of this as an &quot;atom&quot; building block that you can piece together other commands and the behavior tree below together with. Actions have a single function run/2. They accept a conn and params as commands and controllers do. The example below bundles together what it means to speak into a channel, e.g. the room your character is in. defmodule Kantele.Character.SayAction do @moduledoc &quot;&quot;&quot; Action to speak in a channel (e.g. a room) &quot;&quot;&quot; use Kalevala.Character.Action alias Kantele.Character.SayView @impl true def run(conn, params) do conn |&gt; assign(:text, params[&quot;text&quot;]) |&gt; render(SayView, &quot;echo&quot;) |&gt; publish_message(params[&quot;channel_name&quot;], params[&quot;text&quot;], [], &amp;publish_error/2) end def publish_error(conn, _error), do: conn end Character &quot;Brains&quot; - Behavior Tree In order to create non-player characters, you can equip them with a brain of sorts. This comes in the form of a simple behavior tree. The tree evaluates an incoming event and checks to see which branches/leaves trigger. Selectors FirstSelector, starts at the top and tries each node, continuing until the first node succeeds ConditionalSelector, starts at the top and tries each node, continuing as long as nodes succeed RandomSelector, selects a random node to process Sequence, starts at the top and runs each node, ignoring failing nodes Leaves Condition, a node that evaluates the condition, if the condition is false, then the node fails, generally this is matched with a ConditionalSelector at the start to fail the actions below it Action, a node that will append an action to the conn to be performed, optionally delayed NullNode, a no-op node that can be used as an empty brain to skip node operation Conditions MessageMatch, built-in condition to match a Kalevala.Event.Message event EventMatch, built-in condition to match a base Kalevala.Event event Communication &amp; Channels A Kalevala.Communication.Channel is a pub/sub for sending chat messages between characters. Channels are registered with a callback module, allowing for callbacks before subscriptions/unsubscriptions/publishes. For instance, rooms can register a channel for themselves, and as characters move around they can change room subscriptions. A say command can then publish to this room, with every other character in the room receiving the event via their subscription. Another example might be a global channel that all characters are subscribed to, or one for a set of characters. By default, the use macro will fill in default implementations that allow all. defmodule Kantele.Communication.BroadcastChannel do use Kalevala.Communication.Channel end defmodule Kantele.Communication do @moduledoc false use Kalevala.Communication @impl true def initial_channels() do [{&quot;general&quot;, Kantele.Communication.BroadcastChannel, []}] end end The World The world in Kalevala consists of Kalevala.World.Zones and Kalevala.World.Rooms. A zone contains many rooms, and rooms are the basic block of traversing the world. Rooms also act as the primary point of work (processing events) as all events will go through the room that characters are in. The example game boots the world from flat files, but world data can come from any source as long as the structures can be created. For instance, you might load a simple zone struct with a database ID and hydrate the zone after the process started.","ref":"readme.html#components-of-kalevala","title":"Kalevala - Components of Kalevala","type":"extras"}]